function updateProgressBar(width, value) {
    $('#progressbar').width(width+'%');
    $('#progressbar-text').text(value);
}


function migrate(entries, callback) {
    $.post(EE.maps_field_type_base_url.base+'?cp/'+EE.maps_field_type_base_url.path+'/migrate_gmaps&action=migrate_entries&S='+EE.maps_field_type_base_url.session_id, {entries: entries}, function(result){
        callback();
    });
}

function get_migration_data(limit, offset) {
    $.get(EE.maps_field_type_base_url.base+'?cp/'+EE.maps_field_type_base_url.path+'/migrate_gmaps&action=get_migration_entries&limit='+limit+'&offset='+offset+'&S='+EE.maps_field_type_base_url.session_id, function(entries){
        entries = $.parseJSON(entries);

        if(entries != null) {
            migrate(entries, function(){
                updateProgressBar(60, 'Migrate '+(offset + 1)+' entries so far');
                get_migration_data(limit, offset + 1);
            });

        } else {
            updateProgressBar(100, 'Done, Gmaps data is converted to Maps');
        }

    });
}

$(function(){

    $('#start_migration').click(function(){

        $('.progress-bar').show();

        $('#migrate_buttons').remove();

        //show progress bar
        updateProgressBar(10, 'Looking for Gmaps Fieldtypes');

        //looking for the fields
        $.get(EE.maps_field_type_base_url.base+'?cp/'+EE.maps_field_type_base_url.path+'/migrate_gmaps&action=save_fields&S='+EE.maps_field_type_base_url.session_id, function(has_fields){

            if(has_fields) {
                updateProgressBar(20, 'Move old Gmaps data to the migration table');

                //move the entries to a backup table
                $.get(EE.maps_field_type_base_url.base+'?cp/'+EE.maps_field_type_base_url.path+'/migrate_gmaps&action=save_entries&S='+EE.maps_field_type_base_url.session_id, function(){

                    updateProgressBar(40, 'Migrate Fields');

                    //move the entries to a backup table
                    $.get(EE.maps_field_type_base_url.base+'?cp/'+EE.maps_field_type_base_url.path+'/migrate_gmaps&action=migrate_fields&S='+EE.maps_field_type_base_url.session_id, function(){

                        updateProgressBar(40, 'Migrate entries');
                        get_migration_data(1, 0);
                    });


                });
            } else {
                updateProgressBar(100, 'Done, no Gmaps fields found');
            }
        });

        return false;
    });

    $('#start_migration_from_backup').click(function(){

        $('.progress-bar').show();

        $('#migrate_buttons').remove();


        //show progress bar
        updateProgressBar(20, 'Looking for Gmaps backup data');

        //move the entries to a backup table
        $.get(EE.maps_field_type_base_url.base+'?cp/'+EE.maps_field_type_base_url.path+'/migrate_gmaps&action=has_backup_data&S='+EE.maps_field_type_base_url.session_id, function(has_backup_data){

            //move the entries to a backup table
            $.get(EE.maps_field_type_base_url.base+'?cp/'+EE.maps_field_type_base_url.path+'/migrate_gmaps&action=migrate_fields&S='+EE.maps_field_type_base_url.session_id, function(){

                updateProgressBar(40, 'Migrate entries');
                get_migration_data(1, 0);
            });
        });

        return false;
    });
});
